Leetcode338. Counting Bits

Leetcode338. Counting Bits

Given a non negative integer number num. For every numbers i in the range 0 ≤ i ≤ num calculate the number of 1’s in their binary representation and return them as an array.

Example 1:

Input: 2
Output: [0,1,1]

Example 2:

Input: 5
Output: [0,1,1,2,1,2]

Follow up:

  • It is very easy to come up with a solution with run time O(n*sizeof(integer)). But can you do it in linear time O(n) /possibly in a single pass?
  • Space complexity should be O(n).
  • Can you do it like a boss? Do it without using any builtin function like __builtin_popcount in c++ or in any other language.
二进制的特性
  1. 奇数的二进制中 1 的个数 = 它前一位偶数的二进制中 1 的个数 + 1
    ( 3 ) 10 = ( 11 ) 2 ← → ( 2 ) 10 = ( 10 ) 2 (3)_{10} = (11)_2\leftarrow \rightarrow(2)_{10} = (10)_2 (3)10=(11)2(2)10=(10)2
    ( 13 ) 10 = ( 1101 ) 2 ← → ( 12 ) 10 = ( 1100 ) 2 (13)_{10} = (1101)_2\leftarrow \rightarrow(12)_{10} = (1100)_2 (13)10=(1101)2(12)10=(1100)2
  2. 偶数中二进制 1 的个数 = 这个偶数除以 2 后的数的二进制 1 的个数
    因为偶数最低位是 0,除以 2 就是右移一位( > > > > >>),所以 1 的个数是不变的。
    ( 20 ) 10 = ( 10100 ) 2 > > 1 = ( 1010 ) 2 = ( 10 ) 10 (20)_{10} = (10100)_2 >>1 = (1010)_2=(10)_{10} (20)10=(10100)2>>1=(1010)2=(10)10
动态规划

dp[i]为数i的二进制中 1 的个数。

d p [ i ] = { d p [ i − 1 ] + 1 i m o d    2 = = 1 d p [ i / 2 ] i m o d    2 = = 0 dp[i] = \left\{\begin{matrix} dp[i-1]+1 & i\mod2==1 \\ dp[i/2] & i\mod2==0 \end{matrix}\right. dp[i]={dp[i1]+1dp[i/2]imod2==1imod2==0

public int[] countBits(int num) {
    if (num < 0) return new int[0];
    int[] dp = new int[num + 1];
    dp[0] = 0;
    for (int i = 1; i <= num; i++) {
        if (i % 2 == 0) {
            dp[i] = dp[i/2];
        } else {
            dp[i] = dp[i-1] + 1;
        }
    }
    return dp;
}
Three-Line Java Solution
public int[] countBits(int num) {
    int[] f = new int[num + 1];
    for (int i=1; i<=num; i++) f[i] = f[i >> 1] + (i & 1);
    return f;
}

Explaination.
Take number X for example, 10011001.
Divide it in 2 parts:
<1>the last digit ( 1 or 0, which is " i&1 ", equivalent to " i%2 " )
<2>the other digits ( the number of 1, which is " f[i >> 1] ", equivalent to " f[i/2] " )

本题更多解法

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值